%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%  BPSOGSA source codes version 1.1                                 %
%                                                                   %
%  Developed in MATLAB R2011b(7.13)                                 %
%                                                                   %
%  Author and programmer: Seyedali Mirjalili                        %
%                                                                   %
%         e-Mail: ali.mirjalili@gmail.com                           %
%                 seyedali.mirjalili@griffithuni.edu.au             %
%                                                                   %
%       Homepage: http://www.alimirjalili.com                       %
%                                                                   %
%   Main paper: S. Mirjalili, G. G. Wang, L. S. Coelho              %
%               Binary optimization using hybrid particle           %
%               swarm optimization and gravitational search         %
%               algorithm, in press, DOI: 10.1007/s00521-014-1629-6 %                      %
%                                                                   %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

clear all 
close all
clc

CostFunction=@(x) MyCost(x); % Modify or replace Mycost.m according to your cost funciton

Max_iteration=1000; % Maximum number of iterations
N=30; % Number of particles
noV=100;

ElitistCheck=1;

%BPSOGSA 
[Fbest,Lbest,ConvergenceCurve,MeanChart]=BPSOGSA(N,noV, Max_iteration,ElitistCheck,CostFunction);

plot(ConvergenceCurve,'DisplayName','BPSOGSA','Color', 'b');
hold on


title(['\fontsize{12}\bf Convergence curve']);
xlabel('\fontsize{12}\bf Iteration');ylabel('\fontsize{12}\bf Average Best-so-far');
legend('\fontsize{10}\bf BPSOGSA',1);
grid on
axis tight

save resuls

