% BPSOGSA code v1.0.
% Generated by Seyedali Mirjalili, 2014.
% 
% The original codes of GSA algorithm was used in this file as
% follows:

% GSA code v1.0.
% Generated by Esmat Rashedi, 2009. 
% Adopted from: "	E. Rashedi, H. Nezamabadi-pour and S. Saryazdi,
% GSA: A Gravitational Search Algorithm, Information sciences, vol. 179,
% no. 13, pp. 2232-2248, 2009."
%
%This function updates the velocity and position of agents.
function [X,V]=move(X,a,V,l,Max_iter,Lbest,N,dim)
%movement.

C1= (-2*(l^3)/(Max_iter^3))+2;
C2=(2*(l^3)/(Max_iter^3)); 
gBest=zeros(dim,N);
for i=1:N
    gBest(:,i)=Lbest;
end

V=rand(dim,N).*V+C1*a+C2*(gBest-X); %eq. (2.9).

for i=1:dim
    for j=1:N
        s=abs(tanh(V(i,j))); %eq. (3.1)
        
        if rand<s
            X(i,j)=~X(i,j); %eq. (3.2)
        end
    end
end